blob: f79717afb3d76ba79361650baac749fd29e1be57 [file] [log] [blame]
khenaidoocfee5f42018-07-19 22:47:38 -04001#
2# Copyright 2016 the original author or authors.
3#
4# Licensed under the Apache License, Version 2.0 (the "License");
5# you may not use this file except in compliance with the License.
6# You may obtain a copy of the License at
7#
8# http://www.apache.org/licenses/LICENSE-2.0
9#
10# Unless required by applicable law or agreed to in writing, software
11# distributed under the License is distributed on an "AS IS" BASIS,
12# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13# See the License for the specific language governing permissions and
14# limitations under the License.
15#
16
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040017# set default shell
18SHELL = bash -e -o pipefail
Kent Hagerman074d0e02019-04-24 17:58:16 -040019
Zack Williams27f59a42019-05-10 09:12:07 -070020# Variables
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040021VERSION ?= $(shell cat ./VERSION)
Zack Williams27f59a42019-05-10 09:12:07 -070022
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040023DOCKER_LABEL_VCS_DIRTY = false
24ifneq ($(shell git ls-files --others --modified --exclude-standard 2>/dev/null | wc -l | sed -e 's/ //g'),0)
25 DOCKER_LABEL_VCS_DIRTY = true
26endif
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040027## Docker related
David K. Bainbridgee14914d2019-05-24 13:43:05 -070028DOCKER_EXTRA_ARGS ?=
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040029DOCKER_REGISTRY ?=
30DOCKER_REPOSITORY ?=
31DOCKER_TAG ?= ${VERSION}$(shell [[ ${DOCKER_LABEL_VCS_DIRTY} == "true" ]] && echo "-dirty" || true)
32RWCORE_IMAGENAME := ${DOCKER_REGISTRY}${DOCKER_REPOSITORY}voltha-rw-core
Andrea Campanella7a6cce22019-12-17 14:10:27 -080033TYPE ?= minimal
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040034
35## Docker labels. Only set ref and commit date if committed
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040036DOCKER_LABEL_VCS_URL ?= $(shell git remote get-url $(shell git remote))
37DOCKER_LABEL_VCS_REF = $(shell git rev-parse HEAD)
38DOCKER_LABEL_BUILD_DATE ?= $(shell date -u "+%Y-%m-%dT%H:%M:%SZ")
39DOCKER_LABEL_COMMIT_DATE = $(shell git show -s --format=%cd --date=iso-strict HEAD)
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040040
girishk5259f8e2019-10-10 18:44:44 +000041# Default is GO111MODULE=auto, which will refuse to use go mod if running
42# go less than 1.13.0 and this repository is checked out in GOPATH. For now,
43# force module usage. This affects commands executed from this Makefile, but
44# not the environment inside the Docker build (which does not build from
45# inside a GOPATH).
46export GO111MODULE=on
47
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040048DOCKER_BUILD_ARGS ?= \
David K. Bainbridgee14914d2019-05-24 13:43:05 -070049 ${DOCKER_EXTRA_ARGS} \
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040050 --build-arg org_label_schema_version="${VERSION}" \
51 --build-arg org_label_schema_vcs_url="${DOCKER_LABEL_VCS_URL}" \
52 --build-arg org_label_schema_vcs_ref="${DOCKER_LABEL_VCS_REF}" \
53 --build-arg org_label_schema_build_date="${DOCKER_LABEL_BUILD_DATE}" \
54 --build-arg org_opencord_vcs_commit_date="${DOCKER_LABEL_COMMIT_DATE}" \
55 --build-arg org_opencord_vcs_dirty="${DOCKER_LABEL_VCS_DIRTY}"
56
57DOCKER_BUILD_ARGS_LOCAL ?= ${DOCKER_BUILD_ARGS} \
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040058 --build-arg LOCAL_PROTOS=${LOCAL_PROTOS}
khenaidoocfee5f42018-07-19 22:47:38 -040059
Kent Hagermand5e8bd52020-01-30 16:30:16 -050060.PHONY: rw_core local-protos
khenaidoocfee5f42018-07-19 22:47:38 -040061
62# This should to be the first and default target in this Makefile
63help:
64 @echo "Usage: make [<target>]"
65 @echo "where available targets are:"
66 @echo
David K. Bainbridge1678e192019-05-17 11:48:29 -070067 @echo "build : Build the docker images."
68 @echo " - If this is the first time you are building, choose 'make build' option."
69 @echo "rw_core : Build the rw_core docker image"
David K. Bainbridge1678e192019-05-17 11:48:29 -070070 @echo "clean : Remove files created by the build and tests"
Zack Williamsb9b1afb2019-12-09 15:28:52 -070071 @echo "distclean : Remove sca directory and clean"
David K. Bainbridge1678e192019-05-17 11:48:29 -070072 @echo "docker-push : Push the docker images to an external repository"
David Bainbridge5f3619c2019-07-10 22:51:09 +000073 @echo "lint-dockerfile : Perform static analysis on Dockerfiles"
David K. Bainbridge1678e192019-05-17 11:48:29 -070074 @echo "lint-style : Verify code is properly gofmt-ed"
75 @echo "lint-sanity : Verify that 'go vet' doesn't report any issues"
girishk5259f8e2019-10-10 18:44:44 +000076 @echo "lint-mod : Verify the integrity of the 'mod' files"
David K. Bainbridge1678e192019-05-17 11:48:29 -070077 @echo "lint : Shorthand for lint-style & lint-sanity"
npujar03b018e2019-11-13 15:29:36 +053078 @echo "sca : Runs various SCA through golangci-lint tool"
David K. Bainbridge1678e192019-05-17 11:48:29 -070079 @echo "test : Generate reports for all go tests"
khenaidoocfee5f42018-07-19 22:47:38 -040080 @echo
81
David K. Bainbridge1678e192019-05-17 11:48:29 -070082## Local Development Helpers
83local-protos:
David K. Bainbridge1678e192019-05-17 11:48:29 -070084ifdef LOCAL_PROTOS
serkant.uluderya2ae470f2020-01-21 11:13:09 -080085 mkdir -p vendor/github.com/opencord/voltha-protos/v3/go
86 cp -r ${LOCAL_PROTOS}/go/* vendor/github.com/opencord/voltha-protos/v3/go
David K. Bainbridge1678e192019-05-17 11:48:29 -070087endif
88
Scott Bakercb7c88a2019-10-16 18:32:48 -070089## Local Development Helpers
90local-lib-go:
91ifdef LOCAL_LIB_GO
serkant.uluderya2ae470f2020-01-21 11:13:09 -080092 mkdir -p vendor/github.com/opencord/voltha-lib-go/v3/pkg
93 cp -r ${LOCAL_LIB_GO}/pkg/* vendor/github.com/opencord/voltha-lib-go/v3/pkg/
Scott Bakercb7c88a2019-10-16 18:32:48 -070094endif
95
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040096## Docker targets
khenaidoocfee5f42018-07-19 22:47:38 -040097
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040098build: docker-build
khenaidoocfee5f42018-07-19 22:47:38 -040099
Kent Hagermand5e8bd52020-01-30 16:30:16 -0500100docker-build: rw_core
sslobodra3ea7d42019-01-16 15:03:16 -0500101
Scott Bakercb7c88a2019-10-16 18:32:48 -0700102rw_core: local-protos local-lib-go
Kent Hagermanf4a3aab2019-05-22 14:42:34 -0400103 docker build $(DOCKER_BUILD_ARGS) -t ${RWCORE_IMAGENAME}:${DOCKER_TAG} -t ${RWCORE_IMAGENAME}:latest -f docker/Dockerfile.rw_core .
khenaidoocfee5f42018-07-19 22:47:38 -0400104
Matt Jeanneret2e3051a2019-05-11 15:01:46 -0400105docker-push:
Kent Hagermanf4a3aab2019-05-22 14:42:34 -0400106 docker push ${RWCORE_IMAGENAME}:${DOCKER_TAG}
Matt Jeanneret2e3051a2019-05-11 15:01:46 -0400107
Andrea Campanella7a6cce22019-12-17 14:10:27 -0800108docker-kind-load:
109 @if [ "`kind get clusters | grep voltha-$(TYPE)`" = '' ]; then echo "no voltha-$(TYPE) cluster found" && exit 1; fi
110 kind load docker-image ${RWCORE_IMAGENAME}:${DOCKER_TAG} --name=voltha-$(TYPE) --nodes $(shell kubectl get nodes --template='{{range .items}}{{.metadata.name}},{{end}}' | rev | cut -c 2- | rev)
Andrea Campanella7a6cce22019-12-17 14:10:27 -0800111
Matt Jeanneret2e3051a2019-05-11 15:01:46 -0400112## lint and unit tests
khenaidood2b6df92018-12-13 16:37:20 -0500113
David Bainbridge5f3619c2019-07-10 22:51:09 +0000114PATH:=$(GOPATH)/bin:$(PATH)
115HADOLINT=$(shell PATH=$(GOPATH):$(PATH) which hadolint)
116lint-dockerfile:
117ifeq (,$(shell PATH=$(GOPATH):$(PATH) which hadolint))
118 mkdir -p $(GOPATH)/bin
119 curl -o $(GOPATH)/bin/hadolint -sNSL https://github.com/hadolint/hadolint/releases/download/v1.17.1/hadolint-$(shell uname -s)-$(shell uname -m)
120 chmod 755 $(GOPATH)/bin/hadolint
121endif
122 @echo "Running Dockerfile lint check ..."
123 @hadolint $$(find . -name "Dockerfile.*")
124 @echo "Dockerfile lint check OK"
125
Kent Hagerman074d0e02019-04-24 17:58:16 -0400126lint-style:
Zack Williams7cf78002019-04-30 21:45:35 -0700127ifeq (,$(shell which gofmt))
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400128 go get -u github.com/golang/go/src/cmd/gofmt
Zack Williams7cf78002019-04-30 21:45:35 -0700129endif
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400130 @echo "Running style check..."
131 @gofmt_out="$$(gofmt -l $$(find . -name '*.go' -not -path './vendor/*'))" ;\
Zack Williams7cf78002019-04-30 21:45:35 -0700132 if [ ! -z "$$gofmt_out" ]; then \
133 echo "$$gofmt_out" ;\
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400134 echo "Style check failed on one or more files ^, run 'go fmt' to fix." ;\
Zack Williams7cf78002019-04-30 21:45:35 -0700135 exit 1 ;\
Kent Hagerman074d0e02019-04-24 17:58:16 -0400136 fi
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400137 @echo "Style check OK"
Kent Hagerman074d0e02019-04-24 17:58:16 -0400138
139lint-sanity:
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400140 @echo "Running sanity check..."
girishk5259f8e2019-10-10 18:44:44 +0000141 @go vet -mod=vendor ./...
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400142 @echo "Sanity check OK"
Kent Hagerman074d0e02019-04-24 17:58:16 -0400143
girishk5259f8e2019-10-10 18:44:44 +0000144lint-mod:
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400145 @echo "Running dependency check..."
girishk5259f8e2019-10-10 18:44:44 +0000146 @go mod verify
Scott Bakere4c2a982019-11-21 16:32:03 -0800147 @echo "Dependency check OK. Running vendor check..."
148 @git status > /dev/null
149 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && echo "`git status`" && exit 1)
150 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && echo "`git status`" && exit 1)
151 go mod tidy
152 go mod vendor
153 @git status > /dev/null
154 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1)
155 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1)
156 @echo "Vendor check OK."
157
Kent Hagerman0ab4cb22019-04-24 13:13:35 -0400158
girishk5259f8e2019-10-10 18:44:44 +0000159lint: lint-style lint-sanity lint-mod lint-dockerfile
Kent Hagerman074d0e02019-04-24 17:58:16 -0400160
Scott Baker18ea5a42019-10-15 16:08:42 -0700161# Rules to automatically install golangci-lint
162GOLANGCI_LINT_TOOL?=$(shell which golangci-lint)
163ifeq (,$(GOLANGCI_LINT_TOOL))
164GOLANGCI_LINT_TOOL=$(GOPATH)/bin/golangci-lint
165golangci_lint_tool_install:
166 # Same version as installed by Jenkins ci-management
167 # Note that install using `go get` is not recommended as per https://github.com/golangci/golangci-lint
168 curl -sfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh| sh -s -- -b $(GOPATH)/bin v1.17.0
169else
170golangci_lint_tool_install:
171endif
David K. Bainbridge1678e192019-05-17 11:48:29 -0700172
Scott Baker18ea5a42019-10-15 16:08:42 -0700173# Rules to automatically install go-junit-report
174GO_JUNIT_REPORT?=$(shell which go-junit-report)
Zack Williams7cf78002019-04-30 21:45:35 -0700175ifeq (,$(GO_JUNIT_REPORT))
Scott Baker18ea5a42019-10-15 16:08:42 -0700176GO_JUNIT_REPORT=$(GOPATH)/bin/go-junit-report
177go_junit_install:
Zack Williams7cf78002019-04-30 21:45:35 -0700178 go get -u github.com/jstemmer/go-junit-report
Scott Baker18ea5a42019-10-15 16:08:42 -0700179else
180go_junit_install:
Zack Williams7cf78002019-04-30 21:45:35 -0700181endif
Scott Baker18ea5a42019-10-15 16:08:42 -0700182
183# Rules to automatically install gocover-covertura
184GOCOVER_COBERTURA?=$(shell which gocover-cobertura)
Zack Williams7cf78002019-04-30 21:45:35 -0700185ifeq (,$(GOCOVER_COBERTURA))
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400186 @GOCOVER_COBERTURA=$(GOPATH)/bin/gocover-cobertura
Scott Baker18ea5a42019-10-15 16:08:42 -0700187gocover_cobertura_install:
188 go get -u github.com/t-yuki/gocover-cobertura
189else
190gocover_cobertura_install:
Zack Williams7cf78002019-04-30 21:45:35 -0700191endif
Scott Baker18ea5a42019-10-15 16:08:42 -0700192
193sca: golangci_lint_tool_install
194 rm -rf ./sca-report
195 @mkdir -p ./sca-report
Kent Hagermand5e8bd52020-01-30 16:30:16 -0500196 $(GOLANGCI_LINT_TOOL) run --deadline=4m -E golint --out-format junit-xml ./rw_core/... ./tests/... ./common/... ./db/... 2>&1 | tee ./sca-report/sca-report.xml
Scott Baker18ea5a42019-10-15 16:08:42 -0700197
Scott Bakercb7c88a2019-10-16 18:32:48 -0700198test: go_junit_install gocover_cobertura_install local-lib-go
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400199 @mkdir -p ./tests/results
girishk5259f8e2019-10-10 18:44:44 +0000200 @go test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\
Zack Williams7cf78002019-04-30 21:45:35 -0700201 RETURN=$$? ;\
202 $(GO_JUNIT_REPORT) < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\
203 $(GOCOVER_COBERTURA) < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\
204 exit $$RETURN
Kent Hagerman074d0e02019-04-24 17:58:16 -0400205
David K. Bainbridge1678e192019-05-17 11:48:29 -0700206clean:
David K. Bainbridge1678e192019-05-17 11:48:29 -0700207
208distclean: clean
Zack Williamsb9b1afb2019-12-09 15:28:52 -0700209 rm -rf ./sca_report
David K. Bainbridge1678e192019-05-17 11:48:29 -0700210
Scott Bakercb7c88a2019-10-16 18:32:48 -0700211mod-update:
212 go mod tidy
213 go mod vendor
214
khenaidoocfee5f42018-07-19 22:47:38 -0400215# end file